#ifndef __GASTATUS_H__
#define __GASTATUS_H__

#include "GAparam.h"

// definition
#define INDEX_HMSW_MIN       0
#define INDEX_HMSW_MAX       1
#define INDEX_HMSW_L99       2
#define INDEX_HMSW_H99       3
#define INDEX_HMSW_AVG       4

struct CGAstatusIO
{
	int				m_level;           // x
	int				m_stat[NUM_STAT];  // Xe[^X
	int				m_point;           // c|Cg
	int				m_cur_xien;        // sXien
	int				m_cur_stat;        // Xe[^X㏸
	int				m_need_point;      // ݂̃Xe[^X㏸ڂ̕Kv|Cg
	bool			m_changed_xien;    // sXien؂ւǂ
	bool			m_changed_stat;    // Xe[^X㏸ڂ؂ւǂ
};

class CGAstatus
{
public:
	// Xe[^X
	int				m_level;                // x
	int				m_stat[NUM_STAT];       // Xe[^X
	int				m_hp;                   // HP
	int				m_mp;                   // MP
	int				m_point;                // c|Cg
	int				m_cur_xien;             // ݂̐sXien
	int				m_cur_stat;             // ݂̃Xe[^X㏸
	int				m_xien_num;             // ݂XienŝɕKvȃXĽ(-1)
	int				m_penalty;              // xIɑIłȂXiens
	bool			m_count;                // 񐔂v
	int				m_count_xien[NUM_XIEN]; // UP
	int				m_count_stat[NUM_STAT]; // 蓮UP
	int				m_need_point;           // ݂̃Xe[^X㏸ڂ̕Kv|Cg

	// p[^(ÓIϐ)
	static CGAparam	*m_param;

	void			init(bool do_count);
	bool			level_up();
	bool			status_up();
	void			change_xien(int xien);
	void			change_stat(int stat);
	void			check_overflow();
	int				calc_score();
	int				calc_score_stat();
	int				calc_score_hpmp();
	int				calc_score_point();
	void			hmsw_distribution(int *hmsw);
	void			hmsw_distribution_random(int v_size, int *v_min, int *v_max, int *v_num, double dist_range, int &out_min, int &out_max);
	int				current_status()
		{ return m_stat[m_cur_stat]; };
	int				current_point()
		{
			if (!m_need_point) m_need_point = current_point_base() + current_point_mod();
			return m_need_point;
		};
	void				current_point_reset()
		{ m_need_point = 0; };
	int				current_point_base()
		{ return m_param->m_sim_stat_req[m_cur_stat]; };
	int				current_point_mod()
		{ return m_param->need_point_100(m_level, current_status()); };

	CGAstatusIO		class_export(CGAstatus *before);
};

#endif // __GASTATUS_H__
