#ifndef __GAUNIT_H__
#define __GAUNIT_H__

#include "GAparam.h"
#include "GAstatus.h"

// definition
#define NUM_ELEM             256
#define ELEM_STARTBIT_TYPE   16
#define ELEM_STARTBIT_VALUE  0
#define ELEM_MASK_TYPE       0xffff0000
#define ELEM_MASK_INDEX      0x0000ffff
#define ELEM_TYPE_NOP        0x00000000
#define ELEM_TYPE_STUP       0x00010000
#define ELEM_TYPE_XIEN       0x00020000
#define ELEM_TYPE_STAT       0x00030000

class CGAunit
{
public:
	int				m_genom_num;                // `q̐
	ETYPE			m_genom[NUM_ELEM];          // `q(sXienEXe[^X㏸ڂ̐؂ւƃx㏸̏)
	CGAstatus		m_status;                   // ݂̈`qł̃Xe[^XEc|Cg
	int				m_score;                    // ݂̈`qł̓Kx
	bool			m_evaled;                   // Kx͌vZς݂̒lǂ

	// p[^(ÓIϐ)
	static CGAparam	*m_param;
	// obNAbvf[^(ÓIϐ)
	static ETYPE	m_backup_genom[NUM_ELEM];
	static CGAstatus m_backup_status[NUM_ELEM];
	static int		m_backup_retcode[NUM_ELEM];

	// RXgN^
	CGAunit();
	CGAunit(CGAunit &src);
	CGAunit&		operator=(CGAunit &src);
	inline ETYPE&	operator[](int idx) { return m_genom[idx]; };

	// `vf
	ETYPE			element();
	ETYPE			element_nop();
	ETYPE			element_stup();
	ETYPE			element_xien();
	ETYPE			element_stat();

	// `q
	void			genom_init();
	void			genom_twice(CGAunit &src1, CGAunit &src2);
	void			genom_unif(CGAunit &src1, CGAunit &src2);
	void			genom_swap(CGAunit &src);
	void			genom_mutate();
	void			genom_modify_swap_element(int pos1, int pos2);
	void			genom_modify_swap_band(int pos11, int pos12, int pos21, int pos22);

	// `q(CGAunit)ƃXe[^X(CGAstatusIO)̕ϊ
	void			class_import(int &io_size, CGAstatusIO *io);
	void			class_export(int &io_size, CGAstatusIO *io);

	// Kx]
	int				eval(bool do_force = false, int *hmsw = NULL);
	void			eval_backup_save(int retcode);
	int				eval_backup_load(int *retcode_list);
	int				eval_accept_elem(ETYPE elem);
	int				eval_up_to_next(int next);
	int				eval_calc_score();

	inline ETYPE conv_idx2elem_stup(int idx)
		{ return ELEM_TYPE_STUP | ((ETYPE)idx << ELEM_STARTBIT_VALUE); };
	inline ETYPE conv_idx2elem_xien(int idx)
		{ return ELEM_TYPE_XIEN | ((ETYPE)idx << ELEM_STARTBIT_VALUE); };
	inline ETYPE conv_idx2elem_stat(int idx)
		{ return ELEM_TYPE_STAT | ((ETYPE)idx << ELEM_STARTBIT_VALUE); };
	inline ETYPE conv_elem2type(ETYPE elem)
		{ return elem & ELEM_MASK_TYPE; };
	inline int   conv_elem2idx(ETYPE elem)
		{ return elem & ELEM_MASK_INDEX; };
};

bool operator==(CGAunit &src1, CGAunit &src2);

// _l
inline int rand_value()
{
	// SFMT
	return (int)(gen_rand32() & 0x7fffffff);
}

// ͈͎w胉_ (0 <= x < range)
inline int rand_range1(int range)
{
	return rand_value() % range;
}

// ͈͎w胉_ (a <= x <= b)
inline int rand_range2(int a, int b)
{
	return a + (rand_value() % (b - a + 1));
}

// 2_
inline bool rand_bool(bool reset = false)
{
	static int rand_bit = 0;
	static int rand_buf = 0;

	if (reset) {
		rand_bit = 0;
		rand_buf = 0;
		return false;
	}

	if (rand_bit == 0) {
		rand_bit = 30;
		rand_buf = rand_value();
	}

	rand_bit--;
	return (rand_buf & (1 << rand_bit)) ? true : false;
}

// 8rbgl
inline int rand_b8()
{
	return rand_value() & 0x000000ff;
}

// 16rbgl
inline int rand_b16()
{
	return rand_value() & 0x0000ffff;
}

// 24rbgl
inline int rand_b24()
{
	return rand_value() & 0x00ffffff;
}

#endif // __GAUNIT_H__
